function Context() {
    var InstanceType = null;
    return {
        InstanceType: InstanceType,
        getInstance: function (store, ns) {
            if (ns === void 0) { ns = ''; }
            var splitNs = ns ? ns.split('/').filter(function (val) { return !!val; }) : [];
            var fixedNs = splitNs.length ? splitNs.join('/') + '/' : '';
            var state = new Proxy(Object.create(null), {
                get: function (target, propertyName) {
                    return splitNs.reduce(function (pState, key) { return pState[key]; }, store.state)[propertyName];
                }
            });
            var commit = new Proxy(Object.create(null), {
                get: function (target, type) {
                    return function (payload, options) { return store.commit(fixedNs + type, payload, options); };
                }
            });
            var dispatch = new Proxy(Object.create(null), {
                get: function (target, type) {
                    return function (payload, options) { return store.dispatch(fixedNs + type, payload, options); };
                }
            });
            var getters = new Proxy(Object.create(null), {
                get: function (target, key) {
                    return store.getters[fixedNs + key];
                }
            });
            return Object.freeze({
                state: state,
                commit: commit,
                dispatch: dispatch,
                getters: getters
            });
        }
    };
}
Context.fromModule = function (module) {
    return Context();
};

export { Context };
