import { ActionContext, ActionTree, CommitOptions, DispatchOptions, GetterTree, MutationTree, Store } from 'vuex';
declare type InferPayload<T> = T extends (_: any, payload?: any, options?: any) => any ? Parameters<T>[1] : never;
declare type InferMutation<T> = T extends undefined | null ? (() => void) & ((payload: undefined, options?: CommitOptions) => void) : (payload: T, options?: CommitOptions) => void;
declare type InferMutations<T> = {
    [Key in keyof T]: InferMutation<InferPayload<T[Key]>>;
};
declare type InferAction<T> = T extends undefined | null ? (() => void) & ((payload: undefined, options?: DispatchOptions) => void) : (payload: T, options?: DispatchOptions) => void;
declare type InferActions<T> = {
    [Key in keyof T]: InferAction<InferPayload<T[Key]>>;
};
declare type InferGetters<T> = {
    [Key in keyof T]: T extends any ? ReturnType<T[Key]> : never;
};
export declare function Context<S extends (() => object) | object = {}, M extends MutationTree<any> = {}, A extends ActionTree<any, any> = {}, G extends GetterTree<any, any> = {}>(): {
    InstanceType: Readonly<{
        state: S extends () => object ? ReturnType<S> : S;
        commit: InferMutations<M>;
        dispatch: InferActions<A>;
        getters: InferGetters<G>;
    }>;
    getInstance(store: Store<any> | ActionContext<any, any>, ns?: string): Readonly<{
        state: S extends () => object ? ReturnType<S> : S;
        commit: InferMutations<M>;
        dispatch: InferActions<A>;
        getters: InferGetters<G>;
    }>;
};
export declare namespace Context {
    var fromModule: <S extends object | (() => object) = {}, M extends MutationTree<any> = {}, A extends ActionTree<any, any> = {}, G extends GetterTree<any, any> = {}>(module: Partial<{
        state: S;
        mutations: M;
        actions: A;
        getters: G;
    }>) => {
        InstanceType: Readonly<{
            state: S extends () => object ? ReturnType<S> : S;
            commit: InferMutations<M>;
            dispatch: InferActions<A>;
            getters: InferGetters<G>;
        }>;
        getInstance(store: Store<any> | ActionContext<any, any>, ns?: string): Readonly<{
            state: S extends () => object ? ReturnType<S> : S;
            commit: InferMutations<M>;
            dispatch: InferActions<A>;
            getters: InferGetters<G>;
        }>;
    };
}
export {};
